<?php
/*
Plugin Name: PEC - COD SDI - P.IVA - C.F. FOR WooCommerce
Plugin URI: https://www.sisisoftware.it/pec-cod-sdi-p-iva-cf-for-woocommerce
Description: Aggiunge i campi PEC, codice destinatario SDI, Partiva IVA e Codice Fiscale ai dati del cliente di WooCommerce per la fattura elettronica obbligatoria dal 2019, aggiunge questi campi nella email dell'ordine.
Author: Pedro Gonzalez
Author URI: https://www.sisisoftware.it
Version: 20210923
License:      GPL2
License URI:  https://www.gnu.org/licenses/gpl-2.0.html

Written by Pedro Gonzalez <pedro@sisisoftware.it>
Codice preso del plugin jog-cart
Non ci sono delle validazioni di partita iva, codice fiscale, indirizzo PEC ne codice destinatario.
Si ringrazia a Luca Riva Studio per i loghi e immagini di copertina del plugin www.lucarivastudio.it

{Plugin Name} is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 2 of the License, or
any later version.
 
{Plugin Name} is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
 
You should have received a copy of the GNU General Public License
along with {Plugin Name}. If not, see {License URI}.
*/

    if ( ! defined( 'ABSPATH' ) ) {
        exit; // Exit if accessed directly
    }
           
     
    
    add_action( 'woocommerce_email_after_order_table', 'woocommerce_email_after_order_table_datiAggiuntivi' );
    function woocommerce_email_after_order_table_datiAggiuntivi( $order ) {
    	?>
    
    	<h3>Dati Aggiuntivi</h3>
    	<table>
    		<tr>
    			<td>PARTITA IVA: </td>
    			<td><?php echo wptexturize( get_post_meta( $order->get_id(), 'partita_iva', true ) ); ?></td>
    		</tr>
    		<tr>
    			<td>CODICE FISCALE: </td>
    			<td><?php echo wptexturize( get_post_meta( $order->get_id(), 'codice_fiscale', true ) ); ?></td>
    		</tr>
    		<tr>
    			<td>PEC: </td>
    			<td><?php echo wptexturize( get_post_meta( $order->get_id(), 'pec', true ) ); ?></td>
    		</tr>
    		<tr>
    			<td>CODICE DESTINATARIO SDI: </td>
    			<td><?php echo wptexturize( get_post_meta( $order->get_id(), 'codice_destinatario', true ) ); ?></td>
    		</tr>
    	</table>
    
    	<?php
    }
    
    
    
    
    
    
    
    
    
    
    
    
    // CODICE FISCALE, PARTITA IVA, PEC e CODICE DESTINATARIO SDI
    
    
    // CODICE FISCALE, per i paesi dell'europa

    
    add_action( 'woocommerce_after_order_notes', 'jc_wc_codice_fiscale_field' );
    function jc_wc_codice_fiscale_field( $checkout ) {
    	
//    	$default = get_option('jc_option_name');
//    	$jc_codice_fiscale_obbligatorio = ( ( array_key_exists ( 'codiceFiscaleObbligatorio', $default ) ? $default['codiceFiscaleObbligatorio'] : 'off' ) == 'on' );
    	$jc_codice_fiscale_obbligatorio = true;
    
    	echo '<div id="jc_wc_codice_fiscale_field"><br><h2>'. __('Codice Fiscale','sisi_theme_domain') .'</h2>';
    	 
    	if ($jc_codice_fiscale_obbligatorio==true){
    		
    		woocommerce_form_field( 'codice_fiscale', array(
    				'type' => 'text',
    				'class' => array('my-field-class form-row-wide'),
    				'label' => __('Inserisci Codice Fiscale','sisi_theme_domain'),
    				'placeholder' => __('Codice Fiscale','sisi_theme_domain'),
    				'required' => true
    		), get_user_meta(get_current_user_id(), 'codice_fiscale', true ));
    		
    	} else {
    		woocommerce_form_field( 'codice_fiscale', array(
    				'type' => 'text',
    				'class' => array('my-field-class form-row-wide'),
    				'label' => __('Inserisci Codice Fiscale','sisi_theme_domain'),
    				'placeholder' => __('Codice Fiscale','sisi_theme_domain'),
    				'required' => false
    		), get_user_meta(get_current_user_id(), 'codice_fiscale', true ));
    		
    	}    	
    	    	 
    	echo '</div>';
    
    	?>
        <script type="text/javascript">
        jQuery('select#billing_country').on('change', function(){
        
        	var country = jQuery('select#billing_country').val();
        	var check_countries = new Array('AT', 'BE', 'BG', 'CY', 'CZ', 'DE', 'DK', 'EE', 'ES', 'FI', 'FR', 'GB', 'GR', 'HU', 'IE', 'IT', 'LT', 'LU', 'LV', 'MT', 'NL', 'PL', 'PT', 'RO', 'SE', 'SI', 'SK', 'IM', 'MC');
        
        	if (country && jQuery.inArray( country, check_countries ) >= 0) {
        		jQuery('#jc_wc_codice_fiscale_field').fadeIn();
        	} else {
        		jQuery('#jc_wc_codice_fiscale_field').fadeOut();
        	jQuery('#jc_wc_codice_fiscale_field input').val('');
        	}
        
        });
        </script>
        <?php
     
    }
    
    /**
     * Process the checkout
     */
    
    add_action('woocommerce_checkout_process', 'jc_wc_codice_fiscale_field_process');
    function jc_wc_codice_fiscale_field_process() {
    	
    	//$default = get_option('jc_option_name');
    	//$jc_codice_fiscale_obbligatorio = ( ( array_key_exists ( 'codiceFiscaleObbligatorio', $default ) ? $default['codiceFiscaleObbligatorio'] : 'off' ) == 'on' );
    	$jc_codice_fiscale_obbligatorio = true;
    	
    	
            if ( $jc_codice_fiscale_obbligatorio == true && ! $_POST['codice_fiscale'] )
                    wc_add_notice( 'Inserisci Codice Fiscale', 'error' );
    }
     
    
    /**
     * Update the order meta with field value
     */
    
    add_action( 'woocommerce_checkout_update_order_meta', 'jc_wc_codice_fiscale_field_update_order_meta' );
    function jc_wc_codice_fiscale_field_update_order_meta( $order_id ) {
            if ( ! empty( $_POST['codice_fiscale'] ) ) {
                    update_post_meta( $order_id, 'codice_fiscale', sanitize_text_field( $_POST['codice_fiscale'] ) );
                    update_user_meta( get_current_user_id(), 'codice_fiscale', sanitize_text_field( $_POST['codice_fiscale'] ) );
            }
    }
     
    
    /**
     * Display field value on the order edit page
     */
    add_action( 'woocommerce_admin_order_data_after_billing_address', 'jc_wc_codice_fiscale_field_display_admin_order_meta', 10, 1 );
    function jc_wc_codice_fiscale_field_display_admin_order_meta($order){
            echo '<p><strong>'. __('Codice Fiscale','sisi_theme_domain') .'</strong> ' . get_post_meta( $order->get_id(), 'codice_fiscale', true ) . '</p>';
    }
    

    
    // PARTITA IVA
    add_action( 'woocommerce_after_order_notes', 'jc_wc_partita_iva_field' );
    function jc_wc_partita_iva_field( $checkout ) {
    
    	echo '<div id="jc_wc_partita_iva_field"><br><h2>'. __('Partita IVA','sisi_theme_domain') .'</h2>';

    	woocommerce_form_field( 'partita_iva', array(
    			'type' => 'text',
    			'class' => array('my-field-class form-row-wide'),
    			'label' => __('Inserisci Partita IVA','sisi_theme_domain'),
    			'placeholder' => __('Partita IVA','sisi_theme_domain'),
    			'required' => true
    	), get_user_meta(get_current_user_id(), 'partita_iva', true ));
    	 
    	 
    	 
    
    	echo '</div>';
    
    	?>
            <script type="text/javascript">
            jQuery('select#billing_country').on('change', function(){
            
            	var country = jQuery('select#billing_country').val();
            	var check_countries = new Array('AT', 'BE', 'BG', 'CY', 'CZ', 'DE', 'DK', 'EE', 'ES', 'FI', 'FR', 'GB', 'GR', 'HU', 'IE', 'IT', 'LT', 'LU', 'LV', 'MT', 'NL', 'PL', 'PT', 'RO', 'SE', 'SI', 'SK', 'IM', 'MC');
            
            	if (country && jQuery.inArray( country, check_countries ) >= 0) {
            		jQuery('#jc_wc_partita_iva_field').fadeIn();
            	} else {
            		jQuery('#jc_wc_partita_iva_field').fadeOut();
            	jQuery('#jc_wc_partita_iva_field input').val('');
            	}
            
            });
            </script>
            <?php
         
        }
        /**
         * Process the checkout
         */
        add_action('woocommerce_checkout_process', 'jc_wc_partita_iva_field_process');
        function jc_wc_partita_iva_field_process() {
        	
        		// partita iva obbligatoria
        		
                if ( ! $_POST['partita_iva'] )  {
                        wc_add_notice( 'Inserisci Partita IVA', 'error' );
                }
                
        }
         
        /**
         * Update the order meta with field value
         */
        add_action( 'woocommerce_checkout_update_order_meta', 'jc_wc_partita_iva_field_update_order_meta' );
        function jc_wc_partita_iva_field_update_order_meta( $order_id ) {
                if ( ! empty( $_POST['partita_iva'] ) ) {
                        update_post_meta( $order_id, 'partita_iva', sanitize_text_field( $_POST['partita_iva'] ) );
                        update_user_meta( get_current_user_id(), 'partita_iva', sanitize_text_field( $_POST['partita_iva'] ) );
                }
        }
         
        /**
         * Display field value on the order edit page
         */
        add_action( 'woocommerce_admin_order_data_after_billing_address', 'jc_wc_partita_iva_field_display_admin_order_meta', 10, 1 );
        function jc_wc_partita_iva_field_display_admin_order_meta($order){
                echo '<p><strong>'. __('Partita IVA','sisi_theme_domain') .'</strong> ' . get_post_meta( $order->get_id(), 'partita_iva', true ) . '</p>';
        }
        
    

        
        
        // PEC - SOLAMENTE SE ITALIA
        add_action( 'woocommerce_after_order_notes', 'jc_wc_pec_field' );
        function jc_wc_pec_field( $checkout ) {
        
        	echo '<div id="jc_wc_pec_field"><br><h2>'. __('PEC','sisi_theme_domain') .'</h2>';
        
        	woocommerce_form_field( 'pec', array(
        			'type' => 'text',
        			'class' => array('my-field-class form-row-wide'),
        			'label' => __('Inserisci PEC','sisi_theme_domain'),
        			'placeholder' => __('PEC','sisi_theme_domain'),
        			'required' => false
        	), get_user_meta(get_current_user_id(), 'pec', true ));
        
        
        
        
        	echo '</div>';
        
        	?>
                    <script type="text/javascript">
                    jQuery('select#billing_country').on('change', function(){
                    
                    	var country = jQuery('select#billing_country').val();
                    	var check_countries = new Array('IT', 'SM');
                    
                    	if (country && jQuery.inArray( country, check_countries ) >= 0) {
                    		jQuery('#jc_wc_pec_field').fadeIn();
                    	} else {
                    		jQuery('#jc_wc_pec_field').fadeOut();
                    	jQuery('#jc_wc_pec_field input').val('');
                    	}
                    
                    });
                    </script>
                    <?php
                 
                }
                /**
                 * Process the checkout
                 */
                add_action('woocommerce_checkout_process', 'jc_wc_pec_field_process');
                function jc_wc_pec_field_process() {
                	
                		// PEC non obbligatoria
                		/*
                        if ( ! $_POST['pec'] )
                                wc_add_notice( 'Inserisci PEC', 'error' );
                        */
                }
                 
                /**
                 * Update the order meta with field value
                 */
                add_action( 'woocommerce_checkout_update_order_meta', 'jc_wc_pec_field_update_order_meta' );
                function jc_wc_pec_field_update_order_meta( $order_id ) {
                        if ( ! empty( $_POST['pec'] ) ) {
                                update_post_meta( $order_id, 'pec', sanitize_text_field( $_POST['pec'] ) );
                                update_user_meta( get_current_user_id(), 'pec', sanitize_text_field( $_POST['pec'] ) );
                        }
                }
                 
                /**
                 * Display field value on the order edit page
                 */
                add_action( 'woocommerce_admin_order_data_after_billing_address', 'jc_wc_pec_field_display_admin_order_meta', 10, 1 );
                function jc_wc_pec_field_display_admin_order_meta($order){
                        echo '<p><strong>'. __('PEC','sisi_theme_domain') .'</strong> ' . get_post_meta( $order->get_id(), 'pec', true ) . '</p>';
                }
                
            
          

                
                // CODICE DESTINATARIO SDI - SOLAMENTE SE ITALIA
                add_action( 'woocommerce_after_order_notes', 'jc_wc_codice_destinatario_field' );
                function jc_wc_codice_destinatario_field( $checkout ) {
                
                	echo '<div id="jc_wc_codice_destinatario_field"><br><h2>'. __('Codice Destinatario SDI','sisi_theme_domain') .'</h2>';
                
                	woocommerce_form_field( 'codice_destinatario', array(
                			'type' => 'text',
                			'class' => array('my-field-class form-row-wide'),
                			'label' => __('Inserisci Codice Destinatario SDI','sisi_theme_domain'),
                			'placeholder' => __('Codice Destinatario SDI','sisi_theme_domain'),
                			'required' => false
                	), get_user_meta(get_current_user_id(), 'codice_destinatario', true ));
                
                
                
                
                	echo '</div>';
                
                	?>
                                    <script type="text/javascript">
                                    jQuery('select#billing_country').on('change', function(){
                                    
                                    	var country = jQuery('select#billing_country').val();
                                    	var check_countries = new Array('IT', 'SM');
                                    
                                    	if (country && jQuery.inArray( country, check_countries ) >= 0) {
                                    		jQuery('#jc_wc_codice_destinatario_field').fadeIn();
                                    	} else {
                                    		jQuery('#jc_wc_codice_destinatario_field').fadeOut();
                                    	jQuery('#jc_wc_codice_destinatario_field input').val('');
                                    	}
                                    
                                    });
                                    </script>
                                    <?php
                                 
                                }
                                /**
                                 * Process the checkout
                                 */
                                add_action('woocommerce_checkout_process', 'jc_wc_codice_destinatario_field_process');
                                function jc_wc_codice_destinatario_field_process() {
                                	
                                		// codice_destinatario non obbligatorio
                                		/*
                                        if ( ! $_POST['codice_destinatario'] )
                                                wc_add_notice( 'Inserisci codice_destinatario', 'error' );
                                        */
                                }
                                 
                                /**
                                 * Update the order meta with field value
                                 */
                                add_action( 'woocommerce_checkout_update_order_meta', 'jc_wc_codice_destinatario_field_update_order_meta' );
                                function jc_wc_codice_destinatario_field_update_order_meta( $order_id ) {
                                        if ( ! empty( $_POST['codice_destinatario'] ) ) {
                                                update_post_meta( $order_id, 'codice_destinatario', sanitize_text_field( $_POST['codice_destinatario'] ) );
                                                update_user_meta( get_current_user_id(), 'codice_destinatario', sanitize_text_field( $_POST['codice_destinatario'] ) );
                                        }
                                }
                                 
                                /**
                                 * Display field value on the order edit page
                                 */
                                add_action( 'woocommerce_admin_order_data_after_billing_address', 'jc_wc_codice_destinatario_field_display_admin_order_meta', 10, 1 );
                                function jc_wc_codice_destinatario_field_display_admin_order_meta($order){
                                        echo '<p><strong>'. __('Codice Destinatario SDI','sisi_theme_domain') .'</strong> ' . get_post_meta( $order->get_id(), 'codice_destinatario', true ) . '</p>';
                                }
                                
        
    
    
?>